#!/bin/bash

# 19/12/2011
# $Revision: 1.27 $

# Questo script serve per verificare se e' disponibile una versione
# dello script piu' aggiornata di quella in uso.

# Controlla che sia presente WGET

################################################################################
buduscript_download_url="http://digilander.libero.it/udasoft/Software/Linux/buduscript"
#buduscript_download_url="http://192.168.0.1/buduscript"
check_up_day_number=7

################################################################################
# FUNCTION #####################################################################
################################################################################
function update_buduscript() {
    package_info=$(cat ${update_file})

    # Verifica se il pacchetto e' un sorgente; se lo e', deve
    # abortire.
    is_source=$(echo "${package_info}" | grep -iF '_src')
    if [ x${is_source} != x ]; then
	echo "/budus sendsess \$current_tab /ECHO BuDuScRiPt Updating (CODE: 001)"
	echo "/budus sendsess \$current_tab /ECHO ATTENZIONE: Il pacchetto installato rappresenta i sorgenti dello script."
	echo "/budus sendsess \$current_tab /ECHO             Non sono in grado di eseguire l'aggiornamento automatico dei sorgenti."
	echo "/budus sendsess \$current_tab /ECHO             Collegarsi al sito ${buduscript_download_url} e procedere manualmente."
	
	exit 1;
    fi
    
    if [ "${package_info}" != "" ]; then
	if [ ! $(which xmessage 2> /dev/null) ]; then
	    echo "/budus sendsess \$current_tab /ECHO BuDuScRiPt Updating: ERRORE: xmessage non trovato, e' necessario installarlo."
	    
	    exit 1;
	fi
	xmessage -center -timeout 30 -button 'No':0,'No e non chiederlo pi':1,'Si':2 "Vuoi aggiornare BuDuScRiPt Plugin automaticamente alla Versione ${buduscript_online_version} ?"
	exit_status=$?

	case ${exit_status} in
	    0)
		echo "/budus sendsess \$current_tab /ECHO %C4,1Aggiornamento automatico del plugin rinviato."
		exit 1;;
	    1)
		echo "/budus sendsess \$current_tab /ECHO %C4,1Aggiornamento automatico del plugin disattivato."
		touch ${budus_checkupdate_lock}
		echo "/budus sendsess \$current_tab /ECHO %C3,1Se vuoi abilitare nuovamente l'aggiornamento automatico di BuDuScRiPt, prego, esegui questo comando: %B/EXEC rm -vf ${budus_checkupdate_lock}"
		exit 1;;
	    2)
		echo "/budus sendsess \$current_tab /ECHO %C4,1ATTENZIONE: E' in corso l'aggiornamento automatico del plugin."
		echo "/budus sendsess \$current_tab /ECHO %C8,1Per disabilitare gli aggiornamenti automatici, usare il comando di menu:%B BuDuScRiPt -> Aggiornamento Automatico"
		echo "/budus sendsess \$current_tab /ECHO %C3,1Tra 60 secondi i dati non salvati saranno persi; se quindi desideri salvare la configurazione corrente o eventuali sentinelle aggiunte/modificate, puoi usare rispettivamente i comandi %B/budus save%O%C3,1 e %B/event save%O%C3,1 ."
		echo "/budus sendsess \$current_tab /ECHO %C3,1Se presenti altre istanze di XChat, attive con l'attuale utente, %Bdevi necessariamente chiuderle immediatamente%O%C3,1, pena il crash e perdita di dati."
		
		current_version_info=$(cat ${update_file} | cut -f2- -d'_' | cut -f1 -d'_')
		online_version_info=$(echo "${buduscript_online_version}" | sed s/\\.//g)
		package_info=$(echo "${package_info}" | sed s/${current_version_info}/${online_version_info}/ | sed 's@_beta@@g')
		
		if [ ! -f ${package_info} ]; then
		    echo "/budus sendsess \$current_tab /ECHO %C3,1Automatic Update | Download:%C7,1 ${package_info}"
		    wget --timeout 16 -t 1 -q ${buduscript_download_url}/${package_info} > /dev/null 2> /dev/null
		    wget --timeout 4 -q -O - --user-agent 'BuDuScRiPt plugin' ${buduscript_download_url}/download.html > /dev/null 2> /dev/null
		fi
		
		if [ ! -f ${package_info} ]; then
		    if [ ${flag_beta_version:-0} == 0 ]; then
			echo "/budus sendsess \$current_tab /ECHO BuDuScRiPt Updating (CODE: 002)"
			echo "/budus sendsess \$current_tab /ECHO ERRORE: Si e' verificato un errore durante la connessione al Server UDA'Software."
			echo "/budus sendsess \$current_tab /ECHO         Se il problema persiste, si consiglia di controllare direttamente a questo indirizzo:"
			echo "/budus sendsess \$current_tab /ECHO         ${buduscript_download_url}/${package_info}"
		    else
			echo "/budus sendsess \$current_tab /ECHO BuDuScRiPt Updating (CODE: 002)"
			echo "/budus sendsess \$current_tab /ECHO ERRORE: Il pacchetto (${package_info}) cercato non risulta presente sul Server UDA'Software."
			echo "/budus sendsess \$current_tab /ECHO         Ricorda che stai usando la versione di beta-testing, non e' garantito il supporto a tutte le versioni di XChat; contattare UDA'Software."
		    fi
		    
		    exit 1;
		fi
		;;
	    *)
		echo "/budus sendsess \$current_tab /ECHO BuDuScRiPt Updating (CODE: 003)"
		echo "/budus sendsess \$current_tab /ECHO ERRORE: Si e' verificato un errore interno (exit_status = ${exit_status})."
	esac
	
	echo "/TIMER 55 ECHO %C4,1ATTENZIONE:%C3,1 Tra pochi secondi BuDuScRiPt sara' re-installato, dopo averne fatto un backup."
	echo "/TIMER 60 UNLOAD budus.so"
	echo "/TIMER 65 EXEC ${0} UPDATE ${package_info}"
	echo "/TIMER 120 LOAD .xchat2/budus.so"
    fi
}

################################################################################
# MAIN #########################################################################
################################################################################
#_____________________________________________________________________
# Messaggio per il terminale di debug (non modificare se non
# strettamente necessario).
echo "$(date +%H:%M:%S)> ${0} ${*}" >&2

################################################################################
# VARIABLES ####################################################################
################################################################################
budus_checkupdate_file="${HOME}/.xchat2/buduscript/budus_checkupdate_file.dat"
budus_checkupdate_lock="${HOME}/.xchat2/buduscript/budus_checkupdate_file.lck"
budus_checkupdate_beta="${HOME}/.xchat2/buduscript/budus_checkupdate_file.beta"
update_file="${HOME}/.xchat2/buduscript/buduscript_update.dat"

################################################################################
if [ ! -f "${budus_checkupdate_beta}" ]; then
    script_web_page="index.html"
    flag_beta_version=0
else
    check_up_day_number=1
    script_web_page="betaversion.html"
    flag_beta_version=1
fi

################################################################################
if [ -f ${budus_checkupdate_lock} ]; then
    exit 1;
fi

if [ ! $(which wget 2> /dev/null) ]; then
    echo "/budus sendsess \$current_tab /ECHO BuDuScRiPt Updating: ERRORE: wget non trovato, e' necessario installarlo."
    
    exit 1;
fi

if [ ! -d /tmp/ ]; then
    echo "/budus sendsess \$current_tab /ECHO BuDuScRiPt Updating: ERRORE: Directory /tmp non trovata, impossibile continuare !"
    
    exit 1;
fi

################################################################################
cd /tmp
current_dir=$(pwd)

if [ "${current_dir}" != "/tmp" ]; then
    echo "/budus sendsess \$current_tab /ECHO BuDuScRiPt Updating: ERRORE: Directory /tmp inaccessibile, impossibile continuare !"
    
    exit 1;
fi

################################################################################
if [ "${1}" == "UPDATE" ]; then
    package_info=${2:-INTERNAL_ERROR}
    
    [ ${package_info} == "INTERNAL_ERROR" ] && \
	printf '[BUDUSCRIPT UPDATE]\t ERRORE GRAVE: Devo abortire l'\''aggiornamento (NO PARAMETER). Contattare UDA'\''Software.\n' && \
	exit 1;
    
    printf '[BUDUSCRIPT UPDATE]\t Aggiornamento di BuDuScRiPt in corso:\n'
    printf '[BUDUSCRIPT UPDATE]\t  * Backup della cartella %s .\n' "${HOME}/.xchat2"
    tar czf ${HOME}/buduscript_update_backup_$(date +%Y%m%d%H%M%S).tar.gz ${HOME}/.xchat2
    
    [ ! -f ${package_info} ] && \
	printf '[BUDUSCRIPT UPDATE]\t ERRORE GRAVE: Devo abortire l'\''aggiornamento (NO PACKAGE). Contattare UDA'\''Software.\n' && \
	exit 1;
    
    printf '[BUDUSCRIPT UPDATE]\t  * Decompressione del pacchetto %s .\n' "${package_info}"
    tar xvzf ${package_info} -C ${HOME}/.xchat2
    
    printf '[BUDUSCRIPT UPDATE]\t  * Esecuzione della procedura di installazione del plugin.\n'
    ${HOME}/.xchat2/buduscript/install.sh 2

    printf '[BUDUSCRIPT UPDATE]\t  * Rimozione dei files temporanei non piu'\'' necessari.\n'
    rm -f ${package_info}

    printf '[BUDUSCRIPT UPDATE]\t Procedura di aggiornamento terminata; tra circa un minuto BuDuScRiPt sara'\'' ricaricato.\n'
    printf 'Eventuali messaggi di errore (relativi al database corrotto) sono fisiologici dopo un aggiornamento. Esiste la possibilita'\'' che XChat vada in crash a seguito del reload; nel caso in cui non riparta in modo permanente e'\'' necessario eliminare manualmente il file "./xchat2/budus.so" e contattare UDA'\''Software.\n'
    
    exit 0;
fi

################################################################################
if [ "${1}" == "CHECK" ]; then
    echo '/budus InsertCommandInQueueTimed(0) 86400 /budus pipe_script_silent $HOME/.xchat2/buduscript/budus_checkupdate.sh CHECK'
    
    if [ ! -f ${budus_checkupdate_file} ]; then
	date +%Y%m%d > ${budus_checkupdate_file}
	if [ ! -f ${budus_checkupdate_file} ]; then
	    echo "/budus sendsess \$current_tab /ECHO %C4,1%BBuDuScRiPt Updating: ERRORE: E' probabile che ci siano problemi con i permessi in scrittura nella directory ${HOME}/.xchat2 ."
	fi
	
	echo "PLUGIN UPDATE: First Check-Up ($(tail -n1 ${budus_checkupdate_file}))" >&2
	exit 1;
    else
	date +%Y%m%d >> ${budus_checkupdate_file}
	
	first_check=$(head -n1 ${budus_checkupdate_file})
	last_check=$(tail -n1 ${budus_checkupdate_file})
	delta_check=$((${last_check} - ${first_check}))
	
	if [ ${delta_check:-0} -lt ${check_up_day_number:-0} ]; then
	    echo "PLUGIN UPDATE: Skip Update (${delta_check:-0})" >&2
	    exit 2;
	fi
	
	date +%Y%m%d > ${budus_checkupdate_file}
	echo "PLUGIN UPDATE: Check-Up ($(tail -n1 ${budus_checkupdate_file}))" >&2
    fi
fi

################################################################################
if [ "${1}" == "FORCE" ]; then
    printf '/budus sendsess $current_tab /ECHO %%B%%C3,1Check Update:\t%%C8,1 Verifico la presenza di una nuova versione di BuDuScRiPt\n'
fi

################################################################################
if [ -f ${script_web_page} ]; then rm -f ${script_web_page}; fi
wget --timeout 9 --user-agent 'BuDuScRiPt plugin' ${buduscript_download_url}/${script_web_page} > /dev/null 2> /dev/null

if [ ! -f ${script_web_page} ]; then
    echo "/budus sendsess \$current_tab /ECHO BuDuScRiPt Updating (CODE: 004)"
    echo "/budus sendsess \$current_tab /ECHO ERRORE: Si e' verificato un errore durante la connessione al server UDA'Software."
    echo "/budus sendsess \$current_tab /ECHO         Se il problema persiste, si consiglia di controllare direttamente a questo indirizzo:"
    echo "/budus sendsess \$current_tab /ECHO         ${buduscript_download_url}"
    
    exit 1;
fi

################################################################################
buduscript_online_version=$(grep -F buduscript_download_version_ ${script_web_page} | cut -f6- -d'"' | cut -f1 -d'"' | sed s/.*_//g)

if [ ! -f ${HOME}/.xchat2/buduscript/version.c ]; then
    echo "/budus sendsess \$current_tab /ECHO BuDuScRiPt Updating (CODE: 005)"
    echo "/budus sendsess \$current_tab /ECHO ERRORE: Impossibile determinare la versione attualmente installata di BuDuScRiPt"
    echo "/budus sendsess \$current_tab /ECHO         Verificare che sia correttamente installato."
    
    exit 1;
fi

################################################################################
buduscript_local_version=$(grep -F Version ${HOME}/.xchat2/buduscript/version.c | cut -f2- -d'"' | cut -f1 -d'"' | cut -f2- -d' ')

################################################################################
if [ "${1}" == "REINSTALL" ]; then
    buduscript_local_version=0
    printf '/budus sendsess $current_tab /ECHO %%B%%C3,1Check Update:\t%%C8,1 Forzo la re-installazione di BuDuScRiPt\n'
fi

################################################################################
if [ "${buduscript_online_version//[^0-9]/}" -gt "${buduscript_local_version//[^0-9]/}" ]; then
    if [ -f ${update_file} ] || [ "${1}" == "REINSTALL" ]; then
	update_buduscript
    else
	echo "/budus sendsess \$current_tab /ECHO %C4,1ATTENZIONE: On-line risulta presente la versione %B${buduscript_online_version}%O%C4,1 e quella installata e' la %B${buduscript_local_version}%O%C4,1 , si consiglia l'aggiornamento ( ${buduscript_download_url} ) ."
    fi
elif [ "${buduscript_online_version//[^0-9]/}" -lt "${buduscript_local_version//[^0-9]/}" ]; then
    echo "/budus sendsess \$current_tab /ECHO %C8,1ATTENZIONE: On-line risulta presente la versione %B${buduscript_online_version}%O%C8,1 e quella installata e' la %B${buduscript_local_version}%O%C8,1.%C3,1 Se non si tratta di una situazione prevista, si consiglia di controllare l'installazione; utilizzare \"BuDuScRiPt -> Re-installa il plugin\" per riparare installazioni difettose o tentare un aggiornamento forzato."
elif [ "${1}" == "FORCE" ]; then
    printf '/budus sendsess $current_tab /ECHO %%B%%C3,1Check Update:\t%%C8,1 La versione installata risulta la pi recente.\n'
fi

################################################################################
rm -f ${script_web_page}
################################################################################